function y = fft29(x,u,ip,op)
% y = fft29(x,u,ip,op)
% y  : the 29 point DFT of x 
% u  : a vector of precomputed multiplicative constants
% ip : input permutation
% op : ouput permutation

y = zeros(29,1);
x = x(ip);                                        % input permutation
x(2:29) = KRED([2,7],[2,1],2,x(2:29));            % reduction operations
y(1) = x(1)+x(2);                                 % DC term calculation
% -------------------- block : 1 -------------------------------------------------
y(2) = x(2)*u(1);                       
% -------------------- block : 2 -------------------------------------------------
y(3) = x(3)*u(2);                       
% -------------------- block : 4 -------------------------------------------------
v = ID2I(1,1,x(4:5));              % v = (I(1) kron D2 kron I(1)) * x(4:5)
v = v.*u(3:5);                          
y(4:5) = ID2tI(1,1,v);             % y(4:5) = (I(1) kron D2' kron I(1)) * v
% -------------------- block : 7 -------------------------------------------------
v = ID3I(2,1,x(6:11));             % v = (I(2) kron D3 kron I(1)) * x(6:11)
v = ID2I(1,5,v);                   % v = (I(1) kron D2 kron I(5)) * v
v = v.*u(6:20);                         
v = ID2tI(1,5,v);                  % v = (I(1) kron D2' kron I(5)) * v
y(6:11) = ID3tI(2,1,v);            % y(6:11) = (I(2) kron D3' kron I(1)) * v
% -------------------- block : 14 = 2 * 7 ----------------------------------------
v = ID3I(2,1,x(12:17));            % v = (I(2) kron D3 kron I(1)) * x(12:17)
v = ID2I(1,5,v);                   % v = (I(1) kron D2 kron I(5)) * v
v = v.*u(21:35);                        
v = ID2tI(1,5,v);                  % v = (I(1) kron D2' kron I(5)) * v
y(12:17) = ID3tI(2,1,v);           % y(12:17) = (I(2) kron D3' kron I(1)) * v
% -------------------- block : 28 = 4 * 7 ----------------------------------------
v = ID3I(4,1,x(18:29));            % v = (I(4) kron D3 kron I(1)) * x(18:29)
v = ID2I(1,10,v);                  % v = (I(1) kron D2 kron I(10)) * v
v = ID2I(3,5,v);                   % v = (I(3) kron D2 kron I(5)) * v
v = v.*u(36:80);                        
v = ID2tI(1,15,v);                 % v = (I(1) kron D2' kron I(15)) * v
v = ID2tI(2,5,v);                  % v = (I(2) kron D2' kron I(5)) * v
y(18:29) = ID3tI(4,1,v);           % y(18:29) = (I(4) kron D3' kron I(1)) * v
% --------------------------------------------------------------------------------
y(2) = y(1)+y(2);                                 % DC term calculation
y(2:29) = tKRED([2,7],[2,1],2,y(2:29));           % transpose reduction operations
y = y(op);                                        % output permutation

% For complex data - 
% Total Number of Real Multiplications : 160
% Total Number of Real Additions: 836

